
with gnat.io; use gnat.io;
with Ada.Numerics.Discrete_Random;
procedure producerconsumer is

   BufferSize: constant :=10;

   -- Random generation
   subtype xxx is integer range 1..10;
   package Random_pack is new Ada.Numerics.Discrete_Random(xxx);
   use Random_pack;
   G : Generator;

   function produce return integer is
   begin
      return random(G);
   end;

   procedure doit(val:in integer) is
   begin
      if produce>5 then
         delay 0.0008;
      end if;
   end;


   task type producer;
   task type consumer;

   task Buffer is
      entry add(val: in integer);
      entry take(val: out integer);
   end Buffer;

   task body Buffer is
      a:array (0..BufferSize-1) of integer;
      inptr, outptr, n:integer;
   begin
      inptr:=0; outptr:=0; n:=0;
      loop
         select
            when n>0 =>
               accept take(val:out integer) do
                  val:=a(outptr);
                  n:=n-1;
                  outptr:=(outptr+1) mod BufferSize;
                  Put(n); new_line;
               end take;
         or
            when n<BufferSize =>
               accept add(val:in integer) do
                  a(inptr):=val;
                  n:=n+1;
                  inptr:=(inptr+1) mod BufferSize;
                  Put(n); new_line;
               end add;
         end select;
      end loop;
   end;

   task body producer is
      val:integer;
   begin
      for i in 1..100 loop
         val:=produce;
         Buffer.add(val);
      end loop;
   end;

   task body consumer is
      val:integer;
   begin
      for i in 1..150 loop
         Buffer.take(val);

         doit(val);
      end loop;
   end;


begin
   declare
      prod1,prod2,prod3:producer;
      cons1,cons2:consumer;
   begin
      null;
   end;
   abort Buffer;
end;
