SYSTEM compute_pi;
(* parallel reference algorithm, used by R. Babb *)
CONST intervalle = 1000;
      width      = 1.0 / float(intervalle);
CONFIGURATION list [1..intervalle];
CONNECTION (* none *);

VECTOR val: real;

PROCEDURE f (VECTOR x: real): VECTOR real;
(* function to be integrated *)
BEGIN
  RETURN(4.0 / (1.0 + x*x))
END f;

BEGIN
  PARALLEL
    (* integral approximation with rectangle-rule *)
    val := width * f( (float(id_no)-0.5) * width );
  ENDPARALLEL;
  WriteReal(REDUCE.sum(val), 15);
END compute_pi.

