SYSTEM Red_COS;

CONST
  maxPE = 100;
  eps = 1.0e-8;
  x0 = PI;


CONFIGURATION lista[maxPE];
CONNECTION desno:lista[i]->lista[i+1].desno;


SCALAR
  i: cardinal;
  x, tacnost, suma: real;
  nizN : array [0..maxPE] of cardinal;
  nizA : array [0..maxPE] of real;

VECTOR
  a : real;
  n : cardinal;


  PROCEDURE Faktor (SCALAR x: real): VECTOR real;
  BEGIN
    RETURN (-x^2 / Float( (2*n)*(2*n-1) ) );
  END Faktor;


  PROCEDURE StampajA (SCALAR size: cardinal);
  SCALAR i : integer;
  begin
    for i:=0 to size do 
      WriteFixPt (nizA[i],5,2);
      WriteString ("  ");
    end;
    WriteLn;
  end StampajA;


  PROCEDURE StampajN (SCALAR size: cardinal);
  SCALAR i : integer;
  begin
    for i:=0 to size do 
      WriteCard (nizN[i],2);
      WriteString ("  ");
    end;
    WriteLn;
  end StampajN;


BEGIN
  WriteString("Unesite argument x -> "); ReadReal(x);
  WriteLn;

  PARALLEL
    a := 1.0;
    n := id_no - 1;
  ENDPARALLEL;
  STORE (a, nizA);  StampajA (10);
  STORE (n, nizN);  StampajN (10);

  i := 0;
  REPEAT
    i := i + 1;
    PARALLEL[0..i]
      PROPAGATE.desno(a);
      IF n >= 1 THEN
        a := a * Faktor(x);
      END;
      tacnost := REDUCE.LAST(a);
    ENDPARALLEL;
    STORE (a, nizA);  StampajA(i);
  UNTIL Abs(tacnost) <= eps;

  PARALLEL[0..i]
    suma := REDUCE.SUM(a);
  ENDPARALLEL;

  WriteLn;
  WriteString('Suma Tejlorovog reda funkcije cos(x)'); WriteLn;
  WriteString('u okolini tacke nula za x = '); WriteFixPt(x, 15,10);
  WriteString(' je '); WriteFixPt(suma, 15,10); WriteString('.'); WriteLn;
  WriteString('Za izracunavanje sume sa tacnoscu od '); WriteReal(eps,10); WriteLn;
  WriteString('koriscen broj procesora je '); WriteCard(i+1, 3); WriteString('.');
  WriteLn;
  WriteLn;
  WriteString("Standardna funkcija COS(X) = ");
  WriteReal (COS(X),10)
END Red_COS.
